!     
!     main
!     
      program main
      implicit none
      include 'ftest.h'

      character*4 groupname
      character*4 othername
      character*4 thirdname
      common /BLOCK1/ groupname, othername, thirdname

      integer this
      integer other
      integer third
      common /BLOCK2/ this, other, third

      integer r, info
      integer desc

      integer A(TSIZE)
      integer table, region
      
      groupname = 'sout'
      othername = 'nort'
      thirdname = 'east'

      call commonfstartup('f90test_sout', r, info)
      if (info .EQ. 0) then
         stop
      end if
      
      if (r .EQ. 0) then
         print *, 'starting tests'
      end if

!     TTABLE <-> TTABLE
      if (r .EQ. 0) then
         print *, 'testing ttable <-> ttable transfers...'
      end if

      table = 2
      do while (table .LE. DESCS)
         call create_table_desc(table, r, desc)
         if (desc .LT. 0) then
            goto 10
         end if
         
         region = 1
         do while (region .LE. XFERS)
            call inittarray(A, table, r)
            call recvtregion(other, region, desc, A, info)
            if (info .NE. 1) then
               goto 10
            end if           
            call verifytrecv(other, A, r, table, region, info)
            call pvmfallstatus(groupname, info, table*10+region)
            if (r .EQ. 0) then
               if (info .EQ. 0) then
                  print *, 'test', table, '.', region, ' failed'
               else
                  print *, 'test', table, '.', region, ' succeeded'
               end if
            end if
            if (info .EQ. 0) then
               call printfarray(A, 1, TSIZE)      
            end if

            region = region + 1
            
            call inittarray(A, table, r)
            call sendtregion(other, region, desc, A, info)
            if (info .NE. 1) then
               goto 10
            end if 

            region = region + 1
         end do
         
         call ic_free_desc(desc)
         table = table + 2
      end do

!     TTABLE <-> BDECOMP
      if (r .EQ. 0) then
         print *, 'testing ttable <-> bdecomp transfers...'
      end if
      
      table = 2
      do while (table .LE. DESCS)
         call create_table_desc(table, r, desc)
         if (desc .LT. 0) then
            goto 10
         end if
         
         region = 1
         do while (region .LE. XFERS)
            call inittarray(A, table, r)
            call recvtregion(third, region, desc, A, info)
            if (info .NE. 1) then
               goto 10
            end if           
            call verifytrecv(third, A, r, table, region, info)
            call pvmfallstatus(groupname, info, table*10+region)
            if (r .EQ. 0) then
               if (info .EQ. 0) then
                  print *, 'test', table, '.', region, ' failed'
               else
                  print *, 'test', table, '.', region, ' succeeded'
               end if
            end if
            if (info .EQ. 0) then
               call printfarray(A, 1, TSIZE)      
            end if
            
            region = region + 1
            
            call inittarray(A, table, r)
            call sendtregion(third, region, desc, A, info)
            if (info .NE. 1) then
               goto 10
            end if 
            
            region = region + 1
         end do
         
         call ic_free_desc(desc)
         table = table + 2
      end do
      
 10   continue

!     clean up
      call ic_free_program(third)
      call ic_free_program(other)
      call ic_quit(this)

      call pvmfbarrier('f90test_sout', TASKS, info)
      call pvmfexit(info)

      if (r .EQ. 0) then
         print *, 'tests complete'
      end if
      end
